%     VIRTUAL FABRIC - программа для получения эффективных свойств текстильных композитов
%     Copyright (C) 2020  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Replace_CTE(Job_Name_Old, Job_Name, Work_Directory, Material_Properties, Yarn_Properties)

global ErrCode;

mat_prop_format = '%.12e';

% Путь ко входному файлу
File_path_in = [Work_Directory '\' Job_Name_Old '.inp'];

% Открытие файла с воксельной моделью
Fin = fopen(File_path_in, 'r');

if (Fin < 0)
    fprintf (1, '\nОшибка функции Replace_CTE: не удалось открыть файл [%s] !\n', File_path_in);
    ErrCode = -1;
    return;
end

% Путь к выходному файлу
File_path_out = [Work_Directory '\' Job_Name '.inp'];

% Открытие выходного файла
Fout = fopen(File_path_out, 'wt');

if (Fout < 0)
    fprintf (1, '\nОшибка функции Replace_CTE: не удалось открыть для записи файл [%s] !\n', File_path_out);
    ErrCode = -1;
    fclose(Fin);
    return;
end

% Чтение входного файла
while (~feof(Fin))
    
    string = fgets(Fin);
    
    if (string(1) == '*')
        
        if (strcmp(strtrim(string), '*Expansion, type=ORTHO'))
            
            fprintf (Fout, '%s\n', strtrim(string));
            string = fgets(Fin); %#ok<NASGU>
            
            fprintf (Fout, [mat_prop_format ', ' mat_prop_format ', ' mat_prop_format '\n'], Yarn_Properties.beta11, Yarn_Properties.beta22, Yarn_Properties.beta33);
            
            continue;
            
        end
        
        if (strcmp(strtrim(string), '*Expansion'))
            
            fprintf (Fout, '%s\n', strtrim(string));
            string = fgets(Fin); %#ok<NASGU>
            
            fprintf (Fout, [mat_prop_format ',\n'], Material_Properties.Matrix_beta);
            
            continue;
            
        end
        
    end
    
    fprintf (Fout, '%s\n', strtrim(string));
    
end

% Закрытие файлов
fclose(Fin);
fclose(Fout);
